﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data.SQLite;
using System.Numerics;
using System.IO;
using Styx.CommonBot.Routines;
using Styx;
using CommonBehaviors.Actions;
using Styx.Common;
using Styx.TreeSharp;
using Styx.CommonBot.Coroutines;
using System.Collections;
using Styx.WoWInternals.WoWObjects;
using Styx.WoWInternals;
using Styx.CommonBot;

namespace DruidRestorationHB
{
    public class DruidRestoration : CombatRoutine
    {
        public override WoWClass Class
        {
            get
            {
                return WoWClass.Druid;
            }
        }

        public override string Name
        {
            get
            {
                return "Restoration Druid by Pasterke";
            }
        }

        public override CapabilityFlags SupportedCapabilities
        {
            get
            {
                return CapabilityFlags.All;
            }
        }

        public override Composite PullBehavior
        {
            get
            {
                return new ActionRunCoroutine(ctx => pullRoutine());
            }
        }
        public override Composite CombatBehavior { get { return new ActionRunCoroutine(ctx => combatRoutine()); } }

        public override bool WantButton { get { return true; } }
        public override void OnButtonPress()
        {
            Logging.Write("Configuration opened!");
            new Setings_Form().Show();
        }
        public override void Initialize()
        {

        }

        public static async Task<bool> pullRoutine()
        {
            await CommonCoroutines.SleepForLagDuration();
            return false;
        }
        public static async Task<bool> combatRoutine()
        {
            if (await CastOnMe(_barkskin, StyxWoW.Me.HealthPercent <= 75)) return true;
            if (await CastOnMe(_innervate, StyxWoW.Me.ManaPercent <= 70)) return true;

            if (await needGhanir()) return true;
            if (await needFlourish()) return true;
            if (await needRegrowthProc()) return true;
            if (await needSwiftmend()) return true;
            if (await needLifebloom()) return true;
            if (await needIronbark()) return true;
            if (await needEfflorescence()) return true;
            if (await needWildGrowth()) return true;
            if (await needRegrowth()) return true;
            if (await needRejuvenation()) return true;
            if (await needHealingTouch()) return true;


            await CommonCoroutines.SleepForLagDuration();
            return false;
        }
        public static bool validTarget(WoWUnit unit, int healthPercent, int maxDistance)
        {
            return unit.IsAlive && unit.Distance <= maxDistance && unit.InLineOfSight && unit.HealthPercent <= healthPercent;
        }

        public static async Task<bool> needFlourish()
        {
            if (!MeInParty) return false;
            if (!CanUseSpell(_flourish)) return false;
            string aWildGrowth = WoWSpell.FromId(_wildGrowth).ToString();
            var t = myParty.Where(p => validTarget(p, 100, 60) && p.HasAura(aWildGrowth)).ToList();
            if (t.Any())
            {
                SpellManager.Cast(_flourish);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            await CommonCoroutines.SleepForLagDuration();
            return false;
        }

        public static async Task<bool> needGhanir()
        {
            if (StyxWoW.Me.Level < 100) return false;
            string aEssence = WoWSpell.FromId(_essenceofGHanir).ToString();
            var weapon = StyxWoW.Me.Inventory.Equipped.MainHand.ToString();
            if (!weapon.Contains(aEssence)) return false;
            if (!MeInParty) return false;
            if (!CanUseSpell(_essenceofGHanir)) return false;
            int playerCount = myParty.Count() > 5 ? 5 : 3;
            var t = myParty.Where(p => validTarget(p, 75, 60)).ToList();
            if (t.Any() && playerCount >= t.Count())
            {
                SpellManager.Cast(_essenceofGHanir);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            await CommonCoroutines.SleepForLagDuration();
            return false;
        }
        public static async Task<bool> needHealingTouch()
        {
            if (!MeInParty) return false;
            if (!CanUseSpell(_healingTouch)) return false;
            var t = myParty.Where(p => validTarget(p, 80, 40)).OrderBy(p => p.HealthPercent).FirstOrDefault();
            if (t != null)
            {
                SpellManager.Cast(_healingTouch, t);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            await CommonCoroutines.SleepForLagDuration();
            return false;
        }
        public static async Task<bool> needSwiftmend()
        {
            if (!MeInParty) return false;
            if (!CanUseSpell(_swiftmend)) return false;
            var t = myParty.Where(p => validTarget(p, 45, 40)).OrderBy(p => p.HealthPercent).FirstOrDefault();
            if (t != null)
            {
                SpellManager.Cast(_swiftmend, t);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            await CommonCoroutines.SleepForLagDuration();
            return false;
        }
        public static async Task<bool> needRegrowthProc()
        {
            if (!MeInParty) return false;
            if (!CanUseSpell(_regrowth)) return false;
            var t = myParty.Where(p => validTarget(p, 95, 40)).OrderBy(p => p.HealthPercent).FirstOrDefault();
            if (t != null)
            {
                SpellManager.Cast(_regrowth, t);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            await CommonCoroutines.SleepForLagDuration();
            return false;
        }
        public static async Task<bool> needRegrowth()
        {
            if (!MeInParty) return false;
            if (!CanUseSpell(_regrowth)) return false;
            string aRegrowth = WoWSpell.FromId(_regrowth).ToString();
            var t = myParty.Where(p => validTarget(p, 80, 40) && !p.HasAura(aRegrowth)).FirstOrDefault();
            if (t != null)
            {
                SpellManager.Cast(_regrowth, t);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            await CommonCoroutines.SleepForLagDuration();
            return false;
        }
        public static async Task<bool> needRejuvenation()
        {
            if (!MeInParty) return false;
            if (!CanUseSpell(_rejuvenation)) return false;
            string aRejuvenation = WoWSpell.FromId(_rejuvenation).ToString();
            var t = myParty.Where(p => validTarget(p, 90, 40) && !p.HasAura(aRejuvenation)).ToList();
            if (t.Any())
            {
                foreach (WoWUnit target in t)
                {
                    SpellManager.Cast(_rejuvenation, target);
                    await CommonCoroutines.SleepForLagDuration();
                }
                return true;
            }
            await CommonCoroutines.SleepForLagDuration();
            return false;
        }
        public static async Task<bool> needWildGrowth()
        {
            if (!MeInParty) return false;
            if (!CanUseSpell(_wildGrowth)) return false;
            var t = myParty.Where(p => validTarget(p, 40, 75)).FirstOrDefault();
            if (t != null)
            {
                Vector3 tPos = t.Location;
                var j = myParty.Where(p => p.IsAlive && p.InLineOfSight && p.Location.Distance(tPos) <= 30 && p.HealthPercent <= 75).ToList();
                int playerCount = myParty.Count() > 5 ? 5 : 3;
                if (j.Count() >= playerCount)
                {
                    SpellManager.Cast(_wildGrowth, t);
                    await CommonCoroutines.SleepForLagDuration();
                    return true;
                }
            }
            await CommonCoroutines.SleepForLagDuration();
            return false;
        }

        public static bool needMushroom
        {
            get
            {
                var t = ObjectManager.GetObjectsOfTypeFast<WoWObject>().Where(o => o.Entry == _efflorescence && o.Guid == StyxWoW.Me.Guid).FirstOrDefault();
                if (t == null) return true;
                if (t != null)
                {
                    Vector3 mPos = t.Location;
                    var j = myTanks.Where(p => p.IsAlive && p.Distance <= 40 && p.InLineOfSight && p.Location.Distance(mPos) <= 12).FirstOrDefault();
                    if (j != null) return false;
                }
                return true;
            }
        }

        public static async Task<bool> needEfflorescence()
        {
            if (!CanUseSpell(_efflorescence)) return false;
            if (!needMushroom) return false;
            if (myTanks.Any())
            {
                WoWUnit target = myTanks.Where(p => validTarget(p, 100, 40)).OrderBy(p => p.HealthPercent).FirstOrDefault();
                if (target != null)
                {
                    SpellManager.Cast(_efflorescence);
                    SpellManager.ClickRemoteLocation(target.Location);
                    await CommonCoroutines.SleepForLagDuration();
                    return true;
                }
            }
            await CommonCoroutines.SleepForLagDuration();
            return false;
        }

        public static async Task<bool> needIronbark()
        {
            if (!CanUseSpell(_ironbark)) return false;
            if (myTanks.Any())
            {
                foreach (WoWUnit unit in myTanks)
                {
                    if (validTarget(unit, 45, 40))
                    {
                        SpellManager.Cast(_ironbark, unit);
                        await CommonCoroutines.SleepForLagDuration();
                        return true;
                    }
                }
            }
            await CommonCoroutines.SleepForLagDuration();
            return false;
        }

        public static async Task<bool> needLifebloom()
        {
            if (!CanUseSpell(_lifebloom)) return false;
            string aLifebloom = WoWSpell.FromId(_lifebloom).ToString();
            WoWUnit target;
            if (!MeInParty && !StyxWoW.Me.HasAura(aLifebloom))
            {
                SpellManager.Cast(_lifebloom, StyxWoW.Me);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            if (myTanks.Any())
            {
                foreach (var u in myTanks)
                {
                    string aura = u.GetAllAuras().ToString();
                    if (aura.Contains(aLifebloom) && aura.Contains(StyxWoW.Me.Guid.ToString())) return false;
                }
                target = myTanks.Where(p => p.IsAlive && p.Distance <= 40 && p.InLineOfSight && p.HasAura(aLifebloom)).FirstOrDefault();
                if (target != null)
                {
                    SpellManager.Cast(_lifebloom, target);
                    await CommonCoroutines.SleepForLagDuration();
                    return true;
                }
                target = myTanks.Where(p => p.IsAlive && p.Distance <= 40 && p.InLineOfSight).FirstOrDefault();
                SpellManager.Cast(_lifebloom, target);
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }
            await CommonCoroutines.SleepForLagDuration();
            return false;
        }
        public static IEnumerable<WoWUnit> myTanks { get { return Groups.getTanks(); } }
        public static IEnumerable<WoWUnit> myParty { get { return Groups.getPartyMembers; } }
        public static bool CanUseSpell(int spell)
        {
            return SpellManager.HasSpell(spell) && !OnCooldown(spell) && SpellManager.CanCast(spell);
        }

        public const int
_barkskin = 22812,
_bearForm = 5487,
_catForm = 768,
_dash = 1850,
_dreamwalk = 193753,
_efflorescence = 145205,
_entanglingRoots = 339,
_essenceofGHanir = 208253,
_flourish = 197721,
_frenziedRegeneration = 22842,
_growl = 6795,
_ealingTouch = 5185,
_innervate = 29166,
_ironbark = 102342,
_ironfur = 192081,
_lifebloom = 33763,
_mangle = 33917,
_naturesControl = 175682,
_moonfire = 8921,
_naturesCure = 88423,
_prowl = 5215,
_rebirth = 20484,
_regrowth = 8936,
_rejuvenation = 774,
_renewal = 108238,
_revitalize = 212040,
_revive = 50769,
_solarWrath = 5176,
_sunfire = 93402,
_swiftmend = 18562,
_thrash = 106832,
_tranquility = 740,
_travelForm = 783,
_ursolsVortex = 102793,
_wildGrowth = 48438,
_healingTouch = 5185,
end = 0;


        public static async Task<bool> CastOnMe(int spell, bool reqs)
        {

            await CommonCoroutines.SleepForLagDuration();
            return true; ;
        }
        public static async Task<bool> CastOn(int spell, bool reqs)
        {

            await CommonCoroutines.SleepForLagDuration();
            return true; ;
        }
        public static async Task<bool> CastOnGround(int spell, WoWUnit unit, bool reqs)
        {

            await CommonCoroutines.SleepForLagDuration();
            return true; ;
        }
        public static bool OnCooldown(int Spell)
        {
            try
            {
                SpellFindResults Results;
                if (SpellManager.FindSpell(Spell, out Results)) { return Results.Override != null ? Results.Override.Cooldown : Results.Original.Cooldown; }
                return false;
            }
            catch (Exception e)
            {
                Logging.Write(e.Message);
                return false;
            }
        }
        public static bool MeInParty { get { return Groups.getPartyMembers.Count() > 0; } }

    }
}
public class Groups
{
    public static IEnumerable<WoWUnit> getPartyMembers
    {
        get
        {
            var l = new List<WoWUnit>();
            try
            {
                var t = StyxWoW.Me.GroupInfo.RaidMembers.Union(StyxWoW.Me.GroupInfo.PartyMembers).ToList();
                foreach (var unit in t)
                {
                    WoWUnit k = ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Where(p => p.Guid == unit.Guid).FirstOrDefault();
                    if (k != null)
                    {
                        l.Add(k);
                    }
                }
                if (l.Any() && !l.Contains(StyxWoW.Me)) l.Add(StyxWoW.Me);
            }
            catch (Exception e) { Logging.Write(e.Message); }
            return l.Any() ? l : null;
        }
    }
    public static IEnumerable<WoWPartyMember> WoWPartyMembers()
    {
        return StyxWoW.Me.GroupInfo.RaidMembers.Union(StyxWoW.Me.GroupInfo.PartyMembers).Distinct().ToList();
    }
    public static IEnumerable<WoWUnit> getTanks()
    {
        try
        {
            if (StyxWoW.Me.MinimapZoneText == "Proving Grounds")
            {
                return ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Where(p => p != null
                    && p.Name == "Oto the Protector");
            }
            else
            {
                var t = WoWPartyMembers().Where(p => p != null && p.HasRole(WoWPartyMember.GroupRole.Tank)).Select(p => p.ToPlayer()).ToList();
                return t.Any() ? t : null;
            }
        }
        catch (Exception e) { Logging.Write(e.Message); return null; }
    }
}
